%%The MIT License (MIT)

%Copyright (c) 2014 Harbing

%Permission is hereby granted, free of charge, to any person obtaining a copy
%of this software and associated documentation files (the "Software"), to deal
%in the Software without restriction, including without limitation the rights
%to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
%copies of the Software, and to permit persons to whom the Software is
%furnished to do so, subject to the following conditions:

%The above copyright notice and this permission notice shall be included in
%all copies or substantial portions of the Software.

%THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
%IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
%FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
%AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
%LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
%OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
%THE SOFTWARE.


function [ average_x, average_y ] = autospot( cropped)
%AUTOSPOT Summary of this function goes here


    
    cropped_min=min(double(min(cropped)))% find the darkest darkness value
    
    cropped_minus_min= double(cropped)-cropped_min% change the brightness and make the darkest point as 0
    
    cropped_d = exp(-cropped_minus_min) % exp the minus value of darkness, will make all gray part as zero and only the darkest part and ajacent as near 1.
    
    row=1:size(cropped_d(:,1))%make a vector from 1 to the size of row
    
    temp=size(cropped_d(1,:))% since the cropped_d(1:0) always shows [1, size], thus a temp is introduced to extract the size
    
    colum=1:temp(1,2)% make a vector from 1 to the size of colum
    
    sum_y= cropped_d' * row' % from here to the end is to sum up all the elements in the cropped_d times its own coodinates and average them. The average value will give the mean coordinates value which is the center of the spot
    
    sum_x= cropped_d * colum'
    
    sum_cropped=sum(cropped_d(:))
    
    average_x=sum(sum_x(:))/sum_cropped
    
    average_y=sum(sum_y(:))/sum_cropped
  

end

